    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2007, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * -------------------------
    028     * SunPNGEncoderAdapter.java
    029     * -------------------------
    030     * (C) Copyright 2004, 2007, by Richard Atkinson and Contributors.
    031     *
    032     * Original Author:  Richard Atkinson;
    033     * Contributor(s):   -;
    034     *
    035     * $Id: SunPNGEncoderAdapter.java,v 1.3.2.3 2007/02/02 14:51:22 mungady Exp $
    036     *
    037     * Changes
    038     * -------
    039     * 01-Aug-2004 : Initial version (RA);
    040     * 02-Feb-2007 : Removed author tags all over JFreeChart sources (DG);
    041     *
    042     */
    043
    044    package org.jfree.chart.encoders;
    045
    046    import javax.imageio.ImageIO;
    047    import java.awt.image.BufferedImage;
    048    import java.io.OutputStream;
    049    import java.io.ByteArrayOutputStream;
    050    import java.io.IOException;
    051
    052    /**
    053     * Adapter class for the Sun PNG Encoder.  The ImageEncoderFactory will only
    054     * return a reference to this class by default if the library has been compiled
    055     * under a JDK 1.4+ and is being run using a JDK 1.4+.
    056     */
    057    public class SunPNGEncoderAdapter implements ImageEncoder {
    058
    059        /**
    060         * Get the quality of the image encoding (always 0.0).
    061         *
    062         * @return A float representing the quality.
    063         */
    064        public float getQuality() {
    065            return 0.0f;
    066        }
    067
    068        /**
    069         * Set the quality of the image encoding (not supported in this
    070         * ImageEncoder).
    071         *
    072         * @param quality  A float representing the quality.
    073         */
    074        public void setQuality(float quality) {
    075            //  No op
    076        }
    077
    078        /**
    079         * Get whether the encoder should encode alpha transparency (always false).
    080         *
    081         * @return Whether the encoder is encoding alpha transparency.
    082         */
    083        public boolean isEncodingAlpha() {
    084            return false;
    085        }
    086
    087        /**
    088         * Set whether the encoder should encode alpha transparency (not
    089         * supported in this ImageEncoder).
    090         *
    091         * @param encodingAlpha  Whether the encoder should encode alpha
    092         *                       transparency.
    093         */
    094        public void setEncodingAlpha(boolean encodingAlpha) {
    095            //  No op
    096        }
    097
    098        /**
    099         * Encodes an image in PNG format.
    100         *
    101         * @param bufferedImage  The image to be encoded.
    102         *
    103         * @return The byte[] that is the encoded image.
    104         *
    105         * @throws IOException
    106         */
    107        public byte[] encode(BufferedImage bufferedImage) throws IOException {
    108            ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
    109            encode(bufferedImage, outputStream);
    110            return outputStream.toByteArray();
    111        }
    112
    113        /**
    114         * Encodes an image in PNG format and writes it to an OutputStream.
    115         *
    116         * @param bufferedImage  The image to be encoded.
    117         * @param outputStream  The OutputStream to write the encoded image to.
    118         * @throws IOException
    119         */
    120        public void encode(BufferedImage bufferedImage, OutputStream outputStream)
    121            throws IOException {
    122            if (bufferedImage == null) {
    123                throw new IllegalArgumentException("Null 'image' argument.");
    124            }
    125            if (outputStream == null) {
    126                throw new IllegalArgumentException("Null 'outputStream' argument.");
    127            }
    128            ImageIO.write(bufferedImage, ImageFormat.PNG, outputStream);
    129        }
    130
    131    }